package net.dries007.tfc.objects.blocks;

import net.dries007.tfc.util.Helpers;
import net.dries007.tfc.util.OreDictionaryHelper;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.item.Item;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import java.util.Random;

public class BlockPeatGrass extends BlockPeat
{
    // Used for connected textures only.
    public static final PropertyBool NORTH = PropertyBool.func_177716_a("north");
    public static final PropertyBool EAST = PropertyBool.func_177716_a("east");
    public static final PropertyBool SOUTH = PropertyBool.func_177716_a("south");
    public static final PropertyBool WEST = PropertyBool.func_177716_a("west");

    public BlockPeatGrass(Material material)
    {
        super(material);
        func_149672_a(SoundType.field_185849_b);
        func_149675_a(true);
        OreDictionaryHelper.register(this, "peat");
        OreDictionaryHelper.register(this, "peat", "grass");
    }

    @Override
    public int func_176201_c(IBlockState state)
    {
        return 0;
    }

    @Override
    protected BlockStateContainer func_180661_e()
    {
        return new BlockStateContainer(this, NORTH, EAST, WEST, SOUTH);
    }

    @SuppressWarnings("deprecation")
    @Override
    public IBlockState func_176221_a(IBlockState state, IBlockAccess world, BlockPos pos)
    {
        pos = pos.func_177982_a(0, -1, 0);
        return state.func_177226_a(NORTH, BlocksTFC.isGrass(world.func_180495_p(pos.func_177972_a(EnumFacing.NORTH))))
                .func_177226_a(EAST, BlocksTFC.isGrass(world.func_180495_p(pos.func_177972_a(EnumFacing.EAST))))
                .func_177226_a(SOUTH, BlocksTFC.isGrass(world.func_180495_p(pos.func_177972_a(EnumFacing.SOUTH))))
                .func_177226_a(WEST, BlocksTFC.isGrass(world.func_180495_p(pos.func_177972_a(EnumFacing.WEST))));
    }

    @Override
    public Item func_180660_a(IBlockState state, Random rand, int fortune)
    {
        //noinspection ConstantConditions
        return Item.func_150898_a(BlocksTFC.PEAT);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public BlockRenderLayer func_180664_k()
    {
        return BlockRenderLayer.CUTOUT;
    }

    @Override
    public void func_180645_a(World world, BlockPos pos, IBlockState state, Random rand)
    {
        if (world.field_72995_K) return;
        Helpers.spreadGrass(world, pos, state, rand);
    }
}
