package net.dries007.tfc.objects.blocks;

import net.dries007.tfc.objects.Wood;
import net.dries007.tfc.util.OreDictionaryHelper;
import net.minecraft.block.Block;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;

import java.util.EnumMap;

public class BlockPlanksTFC extends Block
{
    private static final EnumMap<Wood, BlockPlanksTFC> MAP = new EnumMap<>(Wood.class);

    public static BlockPlanksTFC get(Wood wood)
    {
        return MAP.get(wood);
    }

    public final Wood wood;

    public BlockPlanksTFC(Wood wood)
    {
        super(Material.field_151575_d);
        if (MAP.put(wood, this) != null) throw new IllegalStateException("There can only be one.");
        this.wood = wood;
        func_149672_a(SoundType.field_185848_a);
        func_149711_c(2.0F).func_149752_b(5.0F);
        setHarvestLevel("axe", 0);
        OreDictionaryHelper.register(this, "plank", "wood");
        OreDictionaryHelper.register(this, "plank", "wood", wood);
    }
}
