package net.dries007.tfc.world.classic.genlayers.biome;

import net.dries007.tfc.objects.biomes.BiomesTFC;
import net.dries007.tfc.world.classic.genlayers.GenLayerTFC;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.gen.layer.IntCache;

public class GenLayerDeepOcean extends GenLayerTFC
{
    public GenLayerDeepOcean(long seed, GenLayerTFC parent)
    {
        super(seed);
        this.field_75909_a = parent;
    }

    @Override
    public int[] func_75904_a(int parX, int parZ, int parXSize, int parZSize)
    {
        int xSize = parXSize + 2;
        int zSize = parZSize + 2;
        int thisID;
        int[] parentIDs = this.field_75909_a.func_75904_a(parX - 1, parZ - 1, xSize, zSize);
//        validateIntArray(parentIDs, xSize, zSize);
        int[] outCache = IntCache.func_76445_a(parXSize * parZSize);

        for (int z = 0; z < parZSize; ++z)
        {
            for (int x = 0; x < parXSize; ++x)
            {
                int northID = parentIDs[x + 1 + z * xSize];
                int rightID = parentIDs[x + 2 + (z + 1) * xSize];
                int leftID = parentIDs[x + (z + 1) * xSize];
                int southID = parentIDs[x + 1 + (z + 2) * xSize];
                thisID = parentIDs[x + 1 + (z + 1) * xSize];
                int oceanCount = 0;
                int outIndex = x + z * parXSize;

                if (northID == 0)
                {
                    ++oceanCount;
                }

                if (rightID == 0)
                {
                    ++oceanCount;
                }

                if (leftID == 0)
                {
                    ++oceanCount;
                }

                if (southID == 0)
                {
                    ++oceanCount;
                }

                if (thisID == 0 && oceanCount > 3)
                {
                    outCache[outIndex] = Biome.func_185362_a(BiomesTFC.DEEP_OCEAN);
                }
                else
                {
                    outCache[outIndex] = thisID;
                }
            }
        }

        return outCache;
    }
}
